/*
 * Copyright (c) 1995 Takahide Matsutsuka
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */
/*
 * Header file for REX-5535 (MB89352A (SPC)) SCSI Driver
 *    by Takahide Matsutsuka (matsu@cs.titech.ac.jp) February, 1996
 */
/*
 * $Id: spc.h,v 1.1.6.1 1998/07/27 11:27:41 kim Exp $
 */

/*
 * config flags
 */
#define	SPC_FLAGS_PCCARD_ONLY	0x01

/*
 * SPC I/O port address
 */
#define	SPC_BDID	  0x00
#define	SPC_SCTL	  0x01
#define	SPC_SCMD	  0x02
#define	SPC_TMOD	  0x03
#define	SPC_INTS	  0x04
#define	SPC_PSNS	  0x05
#define	SPC_SSTS	  0x06
#define	SPC_SERR	  0x07
#define	SPC_PCTL	  0x08
#define	SPC_MBC		  0x09
#define	SPC_DREG	  0x0a
#define	SPC_TEMP	  0x0b
#define	SPC_TCH		  0x0c
#define	SPC_TCM		  0x0d
#define	SPC_TCL		  0x0e

/*
 * SPC_SCTL	spc control
 */
#define	SPC_SCTL_ENABLE		0x1b
#define	SPC_SCTL_DISABLE	0x18

/*
 * SPC_SCMD	command
 */
#define	SPC_SCMD_BUSRELEASE	0x00
#define	SPC_SCMD_RESET		0x10
#define	SPC_SCMD_SELECT		0x20
#define	SPC_SCMD_RESETATN	0x40
#define	SPC_SCMD_SETATN		0x60
#define	SPC_SCMD_TRANSFER	0x80
#define	SPC_SCMD_TRANSPAUSE	0xa0
#define	SPC_SCMD_RESETACK	0xc0
#define	SPC_SCMD_SETACK		0xe0

#define	SPC_SCMD_PROGTX		0x8c
#define	SPC_SCMD_PROGRX		0x84

/*
 * SPC_INTS	interrupt sense
 */
#define	SPC_INTS_SELECT		0x80
#define	SPC_INTS_RESELECT	0x40
#define	SPC_INTS_DISCONNECT	0x20
#define	SPC_INTS_COMPLETE	0x10
#define	SPC_INTS_SERVREQ	0x08
#define	SPC_INTS_TIMEOUT	0x04
#define	SPC_INTS_HARDERR	0x02
#define	SPC_INTS_RESET		0x01

/*
 * SPC_PSNS	phase sense
 */
#define	SPC_PSNS_REQ		0x80
#define	SPC_PSNS_ACK		0x40
#define	SPC_PSNS_ATN		0x20	
#define	SPC_PSNS_SEL		0x10
#define	SPC_PSNS_BSY		0x08
#define	SPC_PSNS_MSG		0x04
#define	SPC_PSNS_CD		0x02
#define	SPC_PSNS_IO		0x01

#define SPC_PSNS_PHASE		0x07

/*
 * SPC_SSTS	spc status
 */
#define	SPC_SSTS_INIT		0x80
#define	SPC_SSTS_TARG		0x40
#define	SPC_SSTS_BUSY		0x20	
#define	SPC_SSTS_XFER		0x10
#define	SPC_SSTS_SCSIRST	0x08
#define	SPC_SSTS_TCZERO		0x04
#define	SPC_SSTS_DRFULL		0x02
#define	SPC_SSTS_DREMPTY	0x01

/*
 * SPC_PCTL	phase control
 */
#define	SPC_PCTL_MSG		0x04
#define	SPC_PCTL_CD		0x02
#define	SPC_PCTL_IO		0x01

#define	SPC_PCTL_DATAOUT	0x00
#define	SPC_PCTL_DATAIN		0x01
#define	SPC_PCTL_COMMAND	0x02
#define	SPC_PCTL_STATUS		0x03
#define	SPC_PCTL_MSGOUT		0x06
#define	SPC_PCTL_MSGIN		0x07

/*
 * others
 */
#define SPC_MSG_CMDCOMPLETE	0x00
#define SPC_MSG_SAVEDATAP	0x02
#define SPC_MSG_RESTOREP	0x03
#define SPC_MSG_DISCONNECT	0x04
