/*
 * Copyright (c) HONDA Naofumi, KATO Takenori, 1996.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer as
 *    the first lines of this file unmodified.
 * 2. Redistributions in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * The name of the author may not be used to endorse or promote products
 * derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/* $Id: ncr53c500if.h,v 1.1.6.1 1998/07/27 10:50:24 kim Exp $ */

/***************************************************
 * BUS IO MAPPINGS & NCR53C500 specific inclusion
 ***************************************************/
#ifdef	__NetBSD__
#include <dev/isa/scsi_low_if.h>
#include <dev/isa/ncr53c500reg.h>
#include <dev/isa/ncr53c500hw.h>
#include <dev/isa/ncr53c500var.h>
#include <dev/isa/ncr53c500hw.lst>
#endif	/* __NetBSD__ */

#ifdef	__FreeBSD__
#include <i386/scsi/scsi_low/scsi_low_if.h>
#include <i386/scsi/ncr53c500/ncr53c500reg.h>
#include <i386/scsi/ncr53c500/ncr53c500hw.h>
#include <i386/scsi/ncr53c500/ncr53c500var.h>
#include <i386/scsi/ncr53c500/ncr53c500hw.lst>

#include	"apm.h"
#if NAPM > 0
#include	<machine/apm_bios.h>
#endif /* NAPM > 0 */

/* pccard support */
#include	"card.h"
#if NCARD > 0
#include	<sys/select.h>
#include	<pccard/cardinfo.h>
#include	<pccard/slot.h>
#include	<pccard/driver.h>
#endif /* NCARD > 0 */
#endif	/* __FreeBSD__ */

int ncv_sequencer __P((struct ncv_softc *sc));
int ncvhw_check __P((struct ncv_softc *));

/* (II) os depend declare */
#ifdef __NetBSD__
int ncvprobe __P((struct device *, struct device *, void *));
void ncvattach __P((struct device *, struct device *, void *));
#endif	/* __NetBSD__ */

#ifdef __FreeBSD__
int ncvprobe __P((struct isa_device *dev));
int ncvattach __P((struct isa_device *dev));
#endif	/* __FreeBSD__ */

#ifdef __FreeBSD__
u_int32_t ncv_adapter_info __P((int));
extern int dma_init_flag;
#define softintr(y) ipending |= (y)
#endif	/* __FreeBSD__ */


#ifdef __NetBSD__
#define DECLARE_IOPORT(sc) \
	register bus_chipset_tag_t bc = (sc)->sc_bc; \
	register bus_io_handle_t ioh = (sc)->sc_ioh;
#define	OUTB(o, val) \
	bus_io_write_1 (bc, ioh, (o), (val))
#define OUTSL(o,b,l) \
	bus_io_write_multi_4(bc, ioh, (o), (b), (l))
#define INB(o) \
	bus_io_read_1 (bc, ioh, (o))
#define INSL(o,b,l) \
	bus_io_read_multi_4(bc, ioh, (o), (b), (l))
#endif

#ifdef __FreeBSD__
#define DECLARE_IOPORT(sc) \
	register int ioport = (sc)->sc_ioport;
#define	OUTB(o, val) \
	outb((o)+ioport, (val))
#define OUTSL(o,b,l) \
	outsl((o)+ioport, (b), (l))
#define INB(o) \
	inb((o)+ioport)
#define INSL(o,b,l) \
	insl((o)+ioport, (b), (l))
#endif
