/*
 * Copyright (c) HONDA Naofumi, KATO Takenori, 1996.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer as
 *    the first lines of this file unmodified.
 * 2. Redistributions in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * The name of the author may not be used to endorse or promote products
 * derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/* $Id: tmc18c30if.h,v 1.1.6.1 1998/07/27 10:49:10 kim Exp $ */

/***************************************************
 * BUS IO MAPPINGS & TMC18C30 specific inclusion
 ***************************************************/
#ifdef	__NetBSD__
#include <dev/isa/scsi_low_if.h>
#include <dev/isa/tmc18c30reg.h>
#include <dev/isa/tmc18c30var.h>
#endif	/* __NetBSD__ */

#ifdef	__FreeBSD__
#include <i386/scsi/scsi_low/scsi_low_if.h>
#include <i386/scsi/tmc18c30/tmc18c30reg.h>
#include <i386/scsi/tmc18c30/tmc18c30var.h>

#include	"apm.h"
#if NAPM > 0
#include	<machine/apm_bios.h>
#endif /* NAPM > 0 */

/* pccard support */
#include	"card.h"
#if NCARD > 0
#include	<sys/select.h>
#include	<pccard/cardinfo.h>
#include	<pccard/slot.h>
#include	<pccard/driver.h>
#endif /* NCARD > 0 */
#endif	/* __FreeBSD__ */

int stg_sequencer __P((struct stg_softc *sc));
int stghw_check __P((struct stg_softc *));

/* (II) os depend declare */
#ifdef __NetBSD__
int stgprobe __P((struct device *, struct device *, void *));
void stgattach __P((struct device *, struct device *, void *));
#endif	/* __NetBSD__ */

#ifdef __FreeBSD__
int stgprobe __P((struct isa_device *dev));
int stgattach __P((struct isa_device *dev));
u_int32_t stg_adapter_info __P((int));
#endif	/* __FreeBSD__ */

#ifdef __NetBSD__
#define DECLARE_IOPORT(sc) \
	register bus_chipset_tag_t bc = (sc)->sc_bc; \
	register bus_io_handle_t ioh = (sc)->sc_ioh;
#define	OUTB(o, val) \
	bus_io_write_1 (bc, ioh, (o), (val))
#define	OUTW(o, val) \
	bus_io_write_2 (bc, ioh, (o), (val))
#define OUTSW(o,b,l) \
	bus_io_write_multi_2(bc, ioh, (o), (b), (l))
#define INB(o) \
	bus_io_read_1 (bc, ioh, (o))
#define INW(o) \
	bus_io_read_2 (bc, ioh, (o))
#define INSW(o,b,l) \
	bus_io_read_multi_2(bc, ioh, (o), (b), (l))
#endif

#ifdef __FreeBSD__
#define DECLARE_IOPORT(sc) \
	register int ioport = (sc)->sc_ioport;
#define	OUTB(o, val) \
	outb((o)+ioport, (val))
#define	OUTW(o, val) \
	outw((o)+ioport, (val))
#define OUTSW(o,b,l) \
	outsw((o)+ioport, (b), (l))
#define INB(o) \
	inb((o)+ioport)
#define INW(o) \
	inw((o)+ioport)
#define INSW(o,b,l) \
	insw((o)+ioport, (b), (l))
#endif
